import { Collection, ItemKey, StorageKey, GroupKey } from '../internal';
/**
 * Will persist the 'collection' into the configured storage with the key or if no key passed the state key
 */
export declare function persistValue(collection: Collection, key?: StorageKey): Promise<boolean>;
/**
 * Set/Update Item in Storage
 */
export declare function setItem(itemKey: ItemKey, collection: Collection): Promise<void>;
/**
 * Removes Item from Storage
 */
export declare function removeItem(itemKey: ItemKey, collection: Collection): void;
/**
 * Updates the Group in the storage
 */
export declare function updateGroup(groupKey: GroupKey, collection: Collection): void;
