import { State, Agile } from '../internal';
export declare class Computed<ComputedValueType = any> extends State<ComputedValueType> {
    agileInstance: () => Agile;
    computeFunction: () => ComputedValueType;
    deps: Array<State>;
    hardCodedDeps: Array<State>;
    constructor(agileInstance: Agile, computeFunction: () => ComputedValueType, deps?: Array<State>);
    set value(value: ComputedValueType);
    get value(): ComputedValueType;
    /**
     * Will call the computeFunction and update the dependencies
     */
    recompute(options?: {
        background?: boolean;
        sideEffects?: boolean;
    }): void;
    /**
     * Updates the Compute Function
     */
    updateComputeFunction(computeFunction: () => ComputedValueType, deps?: Array<State>, options?: {
        background?: boolean;
        sideEffects?: boolean;
    }): void;
    /**
     * @internal
     * Will add auto tracked dependencies to this and calls the computeFunction
     */
    computeValue(): ComputedValueType;
    patch(): this;
    persist(key?: string): this;
}
