import { Agile } from './internal';
/**
 * Copy an array or object.. without any dependencies
 */
export declare function copy<T = any>(value: T): T;
export declare function copy<T extends Array<T>>(value: T): T[];
/**
 * Checks if an Object is an valid object for Agile
 * https://stackoverflow.com/questions/12996871/why-does-typeof-array-with-objects-return-object-and-not-array
 */
export declare function isValidObject(value: any): boolean;
/**
 * Convert item into an array
 */
export declare function normalizeArray<DataType = any>(items?: DataType | Array<DataType>): Array<DataType>;
/**
 * Tries to get AgileInstance from instance(State, Collection)
 */
export declare function getAgileInstance(instance: any): Agile | null;
/**
 * Checks if func is a function
 */
export declare function isFunction(func: any): boolean;
/**
 * Checks if func is a async function
 */
export declare function isAsyncFunction(func: any): boolean;
/**
 * Checks if url is valid
 */
export declare function isValidUrl(url: string): boolean;
/**
 * Checks if value is a valid JsonString
 */
export declare function isJsonString(value: any): boolean;
/**
 * Will create a config (config) and merges default values (default) into this config (config)
 */
export declare function defineConfig<C>(config: C, defaults: object): C;
/**
 * Merged the items flat into the object
 */
export declare function flatMerge<DataType = Object>(source: DataType, changes: Object, config?: {
    addNewProperties?: boolean;
}): DataType;
